SystemOrganization addCategory: #DijEvolution!

!Integer methodsFor: '*DijEvolution' stamp: 'hjo 6/27/2012 15:03'!
multiply: aSmallInteger modulo: aSmallInteger2 

	^(self * aSmallInteger) \\ aSmallInteger2! !

Object subclass: #DijEvolution
	instanceVariableNames: 'ancestors costSortedObjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution'!

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 14:18'!
addSeed: anObject

	costSortedObjects add: (MinClub new evaluator: [:path| path cost ]; put: (DijLife object: anObject cost: 0);yourself).! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 13:49'!
ancestors

	^ ancestors! !

!DijEvolution methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:51'!
costSortedObjects

	^ costSortedObjects! !

!DijEvolution methodsFor: 'initialize-release' stamp: 'hjo 6/27/2012 13:45'!
initialize

	super initialize.
	ancestors := OrderedCollection new. "should be Set?"
	costSortedObjects := SortedCollection sortBlock: [:minClub1 :minClub2| minClub1 minimum <= minClub2 minimum ].! !

!DijEvolution methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 14:17'!
leastCostObject

	^costSortedObjects first! !

!DijEvolution methodsFor: 'stepping and presenter' stamp: 'hjo 6/27/2012 15:02'!
step

	| leastCostMinClub life children |
	leastCostMinClub := costSortedObjects removeFirst.
	ancestors addLast: leastCostMinClub.
	life := leastCostMinClub members anyOne.
	children := 
		{	life giveBirthWith: (Message selector: #multiply:modulo: arguments: #(2 17)).
			life giveBirthWith: (Message selector: #multiply:modulo: arguments: #(3 17))	}.
	self shouldBeImplemented.! !

Object subclass: #DijLife
	instanceVariableNames: 'origin birthMessage birthCost cost object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DijEvolution'!

!DijLife classSide methodsFor: 'instance creation' stamp: 'hjo 6/27/2012 14:18'!
object: anObject 

	^self new object: anObject! !

!DijLife classSide methodsFor: 'instance creation' stamp: 'hjo 6/27/2012 14:18'!
object: anObject cost: aNumber

	^self new object: anObject; cost: aNumber! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
birthCost
	^ birthCost! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
birthCost: anObject
	birthCost := anObject! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
birthMessage
	^ birthMessage! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
birthMessage: anObject
	birthMessage := anObject! !

!DijLife methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 14:59'!
computeCost

	cost := origin cost + birthCost.! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
cost
	^ cost! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 04:08'!
cost: aNumber
	cost := aNumber
! !

!DijLife methodsFor: 'as yet unclassified' stamp: 'hjo 6/27/2012 15:03'!
giveBirthWith: aMessage 

	^self species new 
		origin: self;
		birthMessage: aMessage;
		birthCost: 1;
		object: (aMessage sendTo: object);
		computeCost  ! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 14:50'!
object

	^ object! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:57'!
object: anObject 

	object := anObject! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
origin
	^ origin! !

!DijLife methodsFor: 'accessing' stamp: 'hjo 6/27/2012 13:53'!
origin: anObject
	origin := anObject! !
